%global ruby_sitearch %(ruby -rrbconfig -e 'puts Config::CONFIG["sitearchdir"] ')
%global gemdir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global gemname gherkin
%global geminstdir %{gemdir}/gems/%{gemname}-%{version}
%global rubyabi 1.8

Summary: Fast Gherkin lexer/parser
Name: rubygem-%{gemname}
Version: 2.4.5
Release: 3%{?dist}
Group: Development/Languages
License: MIT
URL: http://github.com/cucumber/gherkin
Source0: http://rubygems.org/gems/%{gemname}-%{version}.gem

# generated by running:
# ruby -rfileutils Dir.glob("gherkin/gherkin-2.4.5/ext/gherkin_lexer_*/").each { |d| Dir.glob("#{d}*.c"){ |f| FileUtils.cp(f,  d + f.split('/').last + ".orig" ) }}
# find ./gherkin/gherkin-2.4.5/ext/ -name *.c -exec sed -i 's/#line.*//g' {} \; 
# ruby -rfileutils Dir.glob('gherkin/gherkin-2.4.5/ext/*/*.c').each { |f| puts `diff -sup #{f}.orig #{f}` }
Patch1: gherkin-2.4.5-remove-hash-line.patch

Patch2: gherkin-2.4.5-fix-gemspec.patch

Requires: ruby(abi) = %{rubyabi}
Requires: rubygems
Requires: rubygem(json)
BuildRequires: ruby(rubygems)
BuildRequires: ruby-devel
Provides: rubygem(%{gemname}) = %{version}

%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires:%{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}


%description
A fast Gherkin lexer/parser based on the Ragel State Machine Compiler.


%prep
%setup -q -c -T
gem unpack %{SOURCE0}
cd %{gemname}-%{version}
%patch1 -p1
%patch2 -p1

%build
pushd %{_builddir}/%{name}-%{version}/%{gemname}-%{version}
pushd ext
for lexer_dir in */ ; do
    pushd $lexer_dir
    CONFIGURE_ARGS="--with-cflags='%{optflags}'" ruby extconf.rb
    make clean && make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"
    make install RUBYARCHDIR="../../lib"
    popd
done
popd
rdoc -o rdoc
rdoc --ri -o ri

%install
mkdir -p %{buildroot}%{geminstdir}
mkdir -p %{buildroot}%{gemdir}/cache
mkdir -p %{buildroot}%{gemdir}/specifications
mkdir -p %{buildroot}%{ruby_sitearch}
mkdir -p %{buildroot}%{gemdir}/doc/%{gemname}-%{version}

for file in Gemfile LICENSE build_native_gems.sh cucumber.yml gherkin.gemspec; do
    cp %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/$file %{buildroot}%{geminstdir}
done

# files for the main package
cp %{SOURCE0} %{buildroot}%{gemdir}/cache/
cp -a %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/features %{buildroot}%{geminstdir}
cp -a %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/lib %{buildroot}%{geminstdir}
# the .so files go in the sitearch, so remove them from lib
find %{buildroot}%{geminstdir} -iname '*.so' -exec rm -f {} \;
cp -a %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/ragel %{buildroot}%{geminstdir}
cp -a %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/spec %{buildroot}%{geminstdir}
cp %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/gherkin.gemspec %{buildroot}/%{gemdir}/specifications/%{gemname}-%{version}.gemspec

find %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/ext -iname '*.so' -exec cp {} %{buildroot}%{ruby_sitearch} \;

# files for the -doc subpackage
cp %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/Rakefile %{buildroot}%{geminstdir}
cp -a %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/tasks %{buildroot}%{geminstdir}
cp -a %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/rdoc %{buildroot}%{gemdir}/doc/%{gemname}-%{version}
cp -a %{_builddir}/%{name}-%{version}/%{gemname}-%{version}/ri %{buildroot}%{gemdir}/doc/%{gemname}-%{version}

# clean out any gitignore
find %{buildroot} -iname '.gitignore' -exec rm -f {} \;

%files
%defattr(-, root, root, -)
%dir %{geminstdir}
%{ruby_sitearch}/%{gemname}_*.so
%{geminstdir}/lib
%{geminstdir}/ragel
%{geminstdir}/build_native_gems.sh
%doc %{geminstdir}/features
%doc %{geminstdir}/spec
%doc %{geminstdir}/LICENSE
%doc %{geminstdir}/cucumber.yml
%doc %{geminstdir}/Gemfile
%{geminstdir}/%{gemname}.gemspec
%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec
%{geminstdir}/Rakefile
%{geminstdir}/tasks

%files doc
%defattr(-, root, root, -)
%{gemdir}/doc/%{gemname}-%{version}

%changelog
* Mon Mar 19 2012 John Eckersberg <jeckersb@redhat.com> - 2.4.5-3
- BZ802891 - Rpmdiff failure(s) for build rubygem-gherkin-2.4.5-2.el6
- Update upstream URL
- Set doc subpackage to noarch to avoid multilib issues
- Don't install the ext directory; it only contains build artifacts
  and we are already moving the .so files over to ruby_sitearch
- Move the Rakefile and tasks over to the main package instead of the
  docs subpackage

* Tue Jul 12 2011 Mo Morsi <mmorsi@redhat.com> - 2.4.5-1
- Update to latest upstream release

* Tue Jun 08 2011 Chris Lalancette <clalance@redhat.com> - 2.3.3-3
- Significantly revamped spec to conform more to fedora standards
- Fix build on Rawhide

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.3.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri Feb 04 2011 Michal Fojtik <mfojtik@redhat.com> - 2.3.3-1
- Version bump

* Fri Sep 24 2010 Michal Fojtik <mfojtik@redhat.com> - 2.2.4-3
- Replaced ~> with >= in JSON version so now it can be used
  with latest json as well

* Fri Sep 24 2010 Michal Fojtik <mfojtik@redhat.com> - 2.2.4-2
- Fixed JSON dependency version

* Fri Sep 24 2010 Michal Fojtik <mfojtik@redhat.com> - 2.2.4-1
- Version bump

* Wed Sep 08 2010 Michal Fojtik <mfojtik@redhat.com> - 2.2.0-1
- Version bump

* Wed Jul 20 2010 Michal Fojtik <mfojtik@redhat.com> - 2.1.5-3
- Fixed rspec and trollop versions in gemspec files

* Wed Jul 20 2010 Michal Fojtik <mfojtik@redhat.com> - 2.1.5-2
- Added -doc subpackage
- Fixed debugging symbols issue (Thanks mtasaka)
- Fixed path for pushd in install section
- Fixed trollop version in gemspec
- Removed '#line foo' from C files

* Wed Jul 19 2010 Michal Fojtik <mfojtik@redhat.com> - 2.1.5-1
- Updated to latest version
- Fixed compiler flags
- Fixed directory ownership
- Removed unwanted versioning files
- Placed .so files on right place

* Wed Jul 14 2010 Michal Fojtik <mfojtik@redhat.com> - 2.1.3-1
- Initial package
